<%@ WebService Language="C#" Class="ComplexTypeWS" %>

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections.Generic;
using Microsoft.Web.Services;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class ComplexTypeWS  : System.Web.Services.WebService {

	[WebMethod]
	public Company Sort(string companyName, Employee[] employees)
	{
		Array.Sort<Employee>(employees);
		
		Company company = new Company();
		company.Name = companyName;
		company.Employees = employees;
		return company;
	}

	[WebMethod]
	[WebOperation(false, ResponseFormatMode.Xml)]
	public Company GetXmlSerializedCompany(Company company)
	{
		return company;
	}
}

[Serializable]
public class Employee : IComparable<Employee>
{
	public string Name;
	
	public int Age;

	#region IComparable<Employee> Members

	public int CompareTo(Employee other)
	{
		return this.Name.CompareTo(other.Name);
	}

	#endregion
}

[Serializable]
public class Company
{
	public string Name;

	public Employee[] Employees;
}

